/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above.

Copyright (C) 2003 Gustavo Bittencourt <g.bitten@bol.com.br>
*/

var dwUtil = new objDwUtil();
var dwPrefService = new objDwPrefService();
var dwPrefApplic = new objDwPrefApplic();
var dwPrefContexMenu = new objDwPrefContexMenu();
var dwPrefAutomatic = new objDwPrefAutomatic();

// Control application tab
function objDwPrefApplic()
{
  var listboxApplication;
  var deleteButton;
  var applicationIdentification;
  var applicationLabel;
  var applicationCommand;
  var applicationArguments;
  var openCommandButton;
  var applicationCaption;

  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Select the command", nsIFilePicker.modeOpen);
  fp.appendFilters(nsIFilePicker.filterAll);

  this.init = function() {
    listboxApplication = document.getElementById("prefListboxApplication");
    deleteButton = document.getElementById("prefDeleteButton");
    applicationIdentification = document.getElementById("prefApplicationIdentification");
    applicationLabel = document.getElementById("prefApplicationLabel");
    applicationCommand = document.getElementById("prefApplicationCommand");
    applicationArguments = document.getElementById("prefApplicationArguments");
    openCommandButton = document.getElementById("prefOpenCommandButton");
    applicationCaption = document.getElementById("prefApplicationCaption");

    application = dwPrefService.getIdentificationArray();
    for (var i = 0; i < application.length; i++) {
      listboxApplication.appendItem(dwPrefService.getApplicationLabel(application[i]),application[i]);
    }
  }

  this.changeSelected = function() {
    application = dwPrefService.getIdentificationArray();
    var i = listboxApplication.selectedIndex;
    if ( i != -1 ) {
      dwUtil.enableElement(deleteButton);
      dwUtil.enableElement(applicationLabel);
      dwUtil.enableElement(applicationCommand);
      dwUtil.enableElement(applicationArguments);
      dwUtil.enableElement(openCommandButton);
      applicationCaption.label = dwPrefService.getApplicationLabel(application[i]);
      applicationIdentification.value = application[i];
      applicationLabel.value = dwPrefService.getApplicationLabel(application[i]);
      applicationCommand.value = dwPrefService.getApplicationCommand(application[i]);
      applicationArguments.value = dwPrefService.getApplicationArguments(application[i]);
    } else {
      dwUtil.disableElement(deleteButton);
      dwUtil.disableElement(applicationLabel);
      dwUtil.disableElement(applicationCommand);
      dwUtil.disableElement(applicationArguments);
      dwUtil.disableElement(openCommandButton);
      applicationCaption.label = null;
      applicationIdentification.value = null;
      applicationLabel.value = null;
      applicationCommand.value = null;
      applicationArguments.value = null;
    }
  }

  this.changePrefs = function() {
    dwPrefService.setApplication(applicationIdentification.value,
                                 applicationLabel.value,
                                 applicationCommand.value,
                                 applicationArguments.value);
    applicationCaption.label = applicationLabel.value;
    listboxApplication.selectedItem.label = applicationLabel.value;
  }

  this.deletePrefs = function() {
    if (applicationIdentification.value != null) {
      if (dwPrefService.delApplication(applicationIdentification.value)) {
        selectIndex = listboxApplication.selectedIndex;
        listboxApplication.removeItemAt(selectIndex);
        this.changeSelected();
        dwPrefAutomatic.update();
      }
    }
  }

  this.createPrefs = function() {
    window.openDialog("chrome://downloadwith/content/pref/downloadwithPrefCreate.xul", 
                      "downloadwithPrefCreate",
                      "chrome,centerscreen,modal=yes,resizable=yes");
  }

  this.add = function(identification,label,command,arguments) {
    if (dwPrefService.isApplication(identification) == false) {
      dwPrefService.addApplication(identification,label,command,arguments);
      listboxApplication.appendItem(label,identification);
      this.changeSelected();
      dwPrefAutomatic.update();
    }
  }

  this.openCommand = function() {
    var res=fp.show();
    if (res==nsIFilePicker.returnOK) {
      applicationCommand.value = fp.file.path;
      this.changePrefs();
    }
  }
}

// Control automatic tab 
function objDwPrefAutomatic()
{
  var groupAllFiles;
  var groupFileTypeList;
  var groupNewEdit;
  var applicationSpecific;
  var fileTypeBox;
  var buttonDelete;
  var applicationAllFiles;
  var radio;
  var radioDisable;
  var radioAll;
  var radioSpecific;

  var listitemArray = new Array();

  this.init = function() {
    groupAllFiles = document.getElementById("prefAutomaticGroupAllFiles");
    groupFileTypeList = document.getElementById("prefAutomaticGroupFileTypeList");
    groupNewEdit = document.getElementById("prefAutomaticGroupNewEdit");
    applicationSpecific = document.getElementById("prefAutomaticApplicationSpecific");
    fileTypeBox = document.getElementById("prefAutomaticFileTypeBox");
    fileTypeList = document.getElementById("prefAutomaticFileTypeList");
    buttonDelete = document.getElementById("prefAutomaticButtonDelete");
    applicationAllFiles = document.getElementById("prefAutomaticApplicationAllFiles");
    radio = document.getElementById("prefAutomaticRadio");
    radioDisable = document.getElementById("prefAutomaticRadioDisable");
    radioAll = document.getElementById("prefAutomaticRadioAll");
    radioSpecific = document.getElementById("prefAutomaticRadioSpecific");

    applicationAllFiles.selectApplication(dwPrefService.getAutoDownloadAllApplication());
    this.updateFileTypeList();

    if (dwPrefService.isAutoDownloadStatusDisable()) { 
      radio.selectedItem = radioDisable;
      this.disable();
    } else if (dwPrefService.isAutoDownloadStatusAll()) {
      radio.selectedItem = radioAll;
      this.allFiles();
    } else if (dwPrefService.isAutoDownloadStatusSpecific()) {
      radio.selectedItem = radioSpecific;
      this.specificFiles();
    }
  }

  this.update = function() {
    applicationSpecific.update();
    applicationAllFiles.update();
    if (dwPrefService.isAutoDownloadStatusDisable()) { 
      radio.selectedItem = radioDisable;
      this.disable();
    } else if (dwPrefService.isAutoDownloadStatusAll()) {
      radio.selectedItem = radioAll;
      this.allFiles();
    } else if (dwPrefService.isAutoDownloadStatusSpecific()) {
      radio.selectedItem = radioSpecific;
      this.specificFiles();
	this.updateFileTypeList();
    }

  } 

  this.changeSelected = function() {
    var i = fileTypeList.selectedIndex;
    if ( i != -1 ) {
      dwUtil.enableElement(buttonDelete);
      fileTypeBox.value = listitemArray[i].getAttribute("fileType");
      applicationSpecific.selectApplication(listitemArray[i].getAttribute("identification"));
    } else {
      dwUtil.disableElement(buttonDelete);
      fileTypeBox.value = "";
    }
  }

  this.disable = function() {
    dwPrefService.setAutoDownloadStatusDisable(); 
    dwUtil.hiddenElement(groupAllFiles);
    dwUtil.hiddenElement(groupFileTypeList);
    dwUtil.hiddenElement(groupNewEdit);
  }

  this.verifyAutomatic = function() {
    if (dwPrefService.isAutoDownloadStatusAll() && this.setApplicationAllFiles()) {
      return true;
    } else {
      radio.selectedItem = radioDisable;
      this.disable();
    }
  }

  this.allFiles = function() {
    if (this.setApplicationAllFiles() && dwPrefService.setAutoDownloadStatusAll()) {
      dwUtil.showElement(groupAllFiles);
      dwUtil.hiddenElement(groupFileTypeList);
      dwUtil.hiddenElement(groupNewEdit);
    } else {
      radio.selectedItem = radioDisable;
      this.disable();
    }
  }

  this.specificFiles = function() {
    dwPrefService.setAutoDownloadStatusSpecific(); 
    dwUtil.hiddenElement(groupAllFiles);
    dwUtil.showElement(groupFileTypeList);
    dwUtil.showElement(groupNewEdit);
    this.updateFileTypeList();
  }

  this.setApplicationAllFiles = function() {
    return dwPrefService.setAutoDownloadAllApplication(applicationAllFiles.identification);
  }

  this.addFileType = function() {
    var identification = applicationSpecific.identification;
    var fileType = fileTypeBox.value;
    dwPrefService.addFileType(identification,fileType);
    this.updateFileTypeList();
  }

  this.deleteFileType = function() {
    selectedItem = fileTypeList.selectedItem;
    dwPrefService.delFileType(selectedItem.getAttribute("fileType"));
    this.updateFileTypeList();
  }

  this.updateFileTypeList = function() {
    for (var i = 0; i < listitemArray.length; i++) {
      listitemArray[i].parentNode.removeChild(listitemArray[i]);
    }
    listitemArray = new Array();
    fileTypeArray = dwPrefService.getFileTypeArray();
    for (var i = 0; i < fileTypeArray.length; i++) {
      identification = dwPrefService.getIdentification(fileTypeArray[i]);
      listitem = document.createElement("listitem");
      listitem.setAttribute("identification",identification);
      listitem.setAttribute("fileType",fileTypeArray[i]);
      listcell = document.createElement("listcell");
      listcell.setAttribute("label",fileTypeArray[i]);
      listitem.appendChild(listcell);
      listcell = document.createElement("listcell");
      listcell.setAttribute("label",dwPrefService.getApplicationLabel(identification));
      listitem.appendChild(listcell);
      fileTypeList.appendChild(listitem);
      listitemArray.push(listitem);
    }
    this.changeSelected();
  }
}

// Control contextmenu tab 
function objDwPrefContexMenu()
{
  var checkbox;

  this.init = function() {
    checkbox = document.getElementById("prefContextMenuShowURL");
    if (dwPrefService.getContextMenuShowUrl())  { checkbox.setAttribute("checked","true"); }
    else { checkbox.setAttribute("checked","false"); }
  }
	
  this.changeShowURL = function() {
    if ( checkbox.getAttribute("checked") == "true" ) { dwPrefService.setContextMenuShowUrl(true); }
    else { dwPrefService.setContextMenuShowUrl(false); }
  }
}